diff --git a/test/periphery-lld/PCA9544A_v1/aos_test_PCA9544A.c b/test/periphery-lld/PCA9544A_v1/aos_test_PCA9544A.c
new file mode 100644
index 0000000..6246621
--- /dev/null
+++ b/test/periphery-lld/PCA9544A_v1/aos_test_PCA9544A.c
@@ -0,0 +1,123 @@
+/*
+AMiRo-OS is an operating system designed for the Autonomous Mini Robot (AMiRo) platform.
+Copyright (C) 2016..2019  Thomas Schöpping et al.
+
+This program is free software: you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation, either version 3 of the License, or
+(at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#include <amiroos.h>
+#include <aos_test_PCA9544A.h>
+
+#if (AMIROOS_CFG_TESTS_ENABLE == true) || defined(__DOXYGEN__)
+
+/******************************************************************************/
+/* LOCAL DEFINITIONS                                                          */
+/******************************************************************************/
+
+/******************************************************************************/
+/* EXPORTED VARIABLES                                                         */
+/******************************************************************************/
+
+/******************************************************************************/
+/* LOCAL TYPES                                                                */
+/******************************************************************************/
+
+/******************************************************************************/
+/* LOCAL VARIABLES                                                            */
+/******************************************************************************/
+
+/******************************************************************************/
+/* LOCAL FUNCTIONS                                                            */
+/******************************************************************************/
+
+/******************************************************************************/
+/* EXPORTED FUNCTIONS                                                         */
+/******************************************************************************/
+
+aos_testresult_t aosTestPca9544aFunc(BaseSequentialStream* stream, const aos_test_t* test)
+{
+  aosDbgCheck(test->data != NULL && ((aos_test_pca9544adata_t*)test->data)->driver != NULL);
+
+  // local variables
+  aos_testresult_t result = {0,0};
+  int32_t status;
+  uint8_t ctrlreg;
+  pca9544a_lld_intstatus_t interrupt;
+  pca9544a_lld_chid_t channel;
+  uint8_t test_mask = 0x00u;
+
+  chprintf(stream, "reading control register...\n");
+  status = pca9544a_lld_read(((aos_test_pca9544adata_t*)test->data)->driver, &ctrlreg, ((aos_test_pca9544adata_t*)test->data)->timeout);
+  if (status == APAL_STATUS_OK || status == APAL_STATUS_WARNING) {
+    aosTestPassed(stream, &result);
+  } else {
+    aosTestFailedMsg(stream, &result, "0x%08X\n", status);
+  }
+
+  chprintf(stream, "writing control register...\n");
+  status = APAL_STATUS_OK;
+  status |= pca9544a_lld_write(((aos_test_pca9544adata_t*)test->data)->driver, (uint8_t)(PCA9544A_LLD_CTRLREG_EN), ((aos_test_pca9544adata_t*)test->data)->timeout);
+  status |= pca9544a_lld_read(((aos_test_pca9544adata_t*)test->data)->driver, &ctrlreg, ((aos_test_pca9544adata_t*)test->data)->timeout);
+  if ((status == APAL_STATUS_OK  || status == APAL_STATUS_WARNING) && ctrlreg == PCA9544A_LLD_CTRLREG_EN) {
+    aosTestPassed(stream, &result);
+  } else {
+    aosTestFailedMsg(stream, &result, "0x%08X, 0x%X\n", status, ctrlreg);
+  }
+
+  chprintf(stream, "reading interrupt status...\n");
+  status = pca9544a_lld_getintstatus(((aos_test_pca9544adata_t*)test->data)->driver, &interrupt, ((aos_test_pca9544adata_t*)test->data)->timeout);
+  if (status == APAL_STATUS_OK || status == APAL_STATUS_WARNING) {
+    aosTestPassedMsg(stream, &result, "0x%08X\n", interrupt);
+  } else {
+    aosTestFailedMsg(stream, &result, "0x%08X\n", status);
+  }
+
+  chprintf(stream, "reading current channel...\n");
+  status = pca9544a_lld_getcurrentchannel(((aos_test_pca9544adata_t*)test->data)->driver, &channel, ((aos_test_pca9544adata_t*)test->data)->timeout);
+  if (status == APAL_STATUS_OK || status == APAL_STATUS_WARNING) {
+    aosTestPassedMsg(stream, &result, "0x%08X\n", channel);
+  } else {
+    aosTestFailedMsg(stream, &result, "0x%08X\n", status);
+  }
+
+  chprintf(stream, "setting current channel...\n");
+  status = APAL_STATUS_OK;
+  status |= pca9544a_lld_setchannel(((aos_test_pca9544adata_t*)test->data)->driver, PCA9544A_LLD_CH0, ((aos_test_pca9544adata_t*)test->data)->timeout);
+  status |= pca9544a_lld_getcurrentchannel(((aos_test_pca9544adata_t*)test->data)->driver, &channel, ((aos_test_pca9544adata_t*)test->data)->timeout);
+  test_mask |= (channel != PCA9544A_LLD_CH0) ? 0x01u : 0x00u;
+  status |= pca9544a_lld_setchannel(((aos_test_pca9544adata_t*)test->data)->driver, PCA9544A_LLD_CH1, ((aos_test_pca9544adata_t*)test->data)->timeout);
+  status |= pca9544a_lld_getcurrentchannel(((aos_test_pca9544adata_t*)test->data)->driver, &channel, ((aos_test_pca9544adata_t*)test->data)->timeout);
+  test_mask |= (channel != PCA9544A_LLD_CH1) ? 0x02u : 0x00u;
+  status |= pca9544a_lld_setchannel(((aos_test_pca9544adata_t*)test->data)->driver, PCA9544A_LLD_CH2, ((aos_test_pca9544adata_t*)test->data)->timeout);
+  status |= pca9544a_lld_getcurrentchannel(((aos_test_pca9544adata_t*)test->data)->driver, &channel, ((aos_test_pca9544adata_t*)test->data)->timeout);
+  test_mask |= (channel != PCA9544A_LLD_CH2) ? 0x04u : 0x00u;
+  status |= pca9544a_lld_setchannel(((aos_test_pca9544adata_t*)test->data)->driver, PCA9544A_LLD_CH3, ((aos_test_pca9544adata_t*)test->data)->timeout);
+  status |= pca9544a_lld_getcurrentchannel(((aos_test_pca9544adata_t*)test->data)->driver, &channel, ((aos_test_pca9544adata_t*)test->data)->timeout);
+  test_mask |= (channel != PCA9544A_LLD_CH3) ? 0x08u : 0x00u;
+  status |= pca9544a_lld_setchannel(((aos_test_pca9544adata_t*)test->data)->driver, PCA9544A_LLD_CH_NONE, ((aos_test_pca9544adata_t*)test->data)->timeout);
+  status |= pca9544a_lld_getcurrentchannel(((aos_test_pca9544adata_t*)test->data)->driver, &channel, ((aos_test_pca9544adata_t*)test->data)->timeout);
+  test_mask |= (channel != PCA9544A_LLD_CH_NONE) ? 0x10u : 0x00u;
+  if ((status == APAL_STATUS_OK || status == APAL_STATUS_WARNING) && test_mask == 0x00u) {
+    aosTestPassed(stream, &result);
+  } else {
+    aosTestFailedMsg(stream, &result, "0x%08X, 0x%X\n", status, test_mask);
+  }
+
+  aosTestInfoMsg(stream,"driver object memory footprint: %u bytes\n", sizeof(PCA9544ADriver));
+
+  return result;
+}
+
+#endif /* (AMIROOS_CFG_TESTS_ENABLE == true) */
+
diff --git a/test/periphery-lld/PCA9544A_v1/aos_test_PCA9544A.h b/test/periphery-lld/PCA9544A_v1/aos_test_PCA9544A.h
new file mode 100644
index 0000000..7704fdb
--- /dev/null
+++ b/test/periphery-lld/PCA9544A_v1/aos_test_PCA9544A.h
@@ -0,0 +1,81 @@
+/*
+AMiRo-OS is an operating system designed for the Autonomous Mini Robot (AMiRo) platform.
+Copyright (C) 2016..2019  Thomas Schöpping et al.
+
+This program is free software: you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation, either version 3 of the License, or
+(at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#ifndef AMIROOS_TEST_PCA9544A_H
+#define AMIROOS_TEST_PCA9544A_H
+
+#include <amiroos.h>
+
+#if (AMIROOS_CFG_TESTS_ENABLE == true) || defined(__DOXYGEN__)
+
+#include <alld_PCA9544A.h>
+
+/******************************************************************************/
+/* CONSTANTS                                                                  */
+/******************************************************************************/
+
+/******************************************************************************/
+/* SETTINGS                                                                   */
+/******************************************************************************/
+
+/******************************************************************************/
+/* CHECKS                                                                     */
+/******************************************************************************/
+
+/******************************************************************************/
+/* DATA STRUCTURES AND TYPES                                                  */
+/******************************************************************************/
+
+/**
+ * @brief   Custom data structure for the test.
+ */
+typedef struct {
+  /**
+   * @brief   Pointer to the driver to use.
+   */
+  PCA9544ADriver *driver;
+
+  /**
+   * @brief   Timeout for bus communication.
+   */
+  apalTime_t timeout;
+} aos_test_pca9544adata_t;
+
+/******************************************************************************/
+/* MACROS                                                                     */
+/******************************************************************************/
+
+/******************************************************************************/
+/* EXTERN DECLARATIONS                                                        */
+/******************************************************************************/
+
+#if defined(__cplusplus)
+extern "C" {
+#endif /* defined(__cplusplus) */
+  aos_testresult_t aosTestPca9544aFunc(BaseSequentialStream* stream, const aos_test_t* test);
+#if defined(__cplusplus)
+}
+#endif /* defined(__cplusplus) */
+
+/******************************************************************************/
+/* INLINE FUNCTIONS                                                           */
+/******************************************************************************/
+
+#endif /* (AMIROOS_CFG_TESTS_ENABLE == true) */
+
+#endif /* AMIROOS_TEST_PCA9544A_H */
diff --git a/test/periphery-lld/PCAL6524_v1/aos_test_PCAL6524.c b/test/periphery-lld/PCAL6524_v1/aos_test_PCAL6524.c
new file mode 100644
index 0000000..81f1cab
--- /dev/null
+++ b/test/periphery-lld/PCAL6524_v1/aos_test_PCAL6524.c
@@ -0,0 +1,164 @@
+/*
+AMiRo-OS is an operating system designed for the Autonomous Mini Robot (AMiRo) platform.
+Copyright (C) 2016..2019  Thomas Schöpping et al.
+
+This program is free software: you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation, either version 3 of the License, or
+(at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#include <amiroos.h>
+#include <aos_test_PCAL6524.h>
+
+#if (AMIROOS_CFG_TESTS_ENABLE == true) || defined(__DOXYGEN__)
+
+#include <string.h>
+
+/******************************************************************************/
+/* LOCAL DEFINITIONS                                                          */
+/******************************************************************************/
+
+/******************************************************************************/
+/* EXPORTED VARIABLES                                                         */
+/******************************************************************************/
+
+/******************************************************************************/
+/* LOCAL TYPES                                                                */
+/******************************************************************************/
+
+/******************************************************************************/
+/* LOCAL VARIABLES                                                            */
+/******************************************************************************/
+
+/******************************************************************************/
+/* LOCAL FUNCTIONS                                                            */
+/******************************************************************************/
+
+/******************************************************************************/
+/* EXPORTED FUNCTIONS                                                         */
+/******************************************************************************/
+
+aos_testresult_t aosTestPcal6524Func(BaseSequentialStream* stream, const aos_test_t* test)
+{
+  aosDbgCheck((test->data != NULL) && (((aos_test_pcal6524data_t*)test->data)->pcal6524d != NULL));
+
+  // local variables
+  aos_testresult_t result = {0, 0};
+  uint32_t status;
+  uint8_t buffer[24];
+  memset(buffer, 0xAA, sizeof(buffer));
+
+// This test is currently not supported. See PCAL6524 driver implementation for further information.
+//  chprintf(stream, "reading device ID...\n");
+//  status = pcal6524_lld_read_id(((aos_test_pcal6524data_t*)test->data)->pcal6524d, buffer, ((aos_test_pcal6524data_t*)test->data)->timeout);
+//  chprintf(stream, "\t\traw: 0x%02X 0x%02X 0x%02X\n", buffer[0], buffer[1], buffer[2]);
+//  chprintf(stream, "\t\tname:     0x%03X\n", ((pcal6524_lld_deviceid_t*)buffer)->name);
+//  chprintf(stream, "\t\tpart:     0x%03X\n", ((pcal6524_lld_deviceid_t*)buffer)->part);
+//  chprintf(stream, "\t\trevision: 0x%01X\n", ((pcal6524_lld_deviceid_t*)buffer)->revision);
+//  if ((status == APAL_STATUS_OK) || (status == APAL_STATUS_WARNING)) {
+//    aosTestPassed(stream, &result);
+//  } else {
+//    aosTestFailedMsg(stream, &result, "0x%08X\n", status);
+//  }
+
+  chprintf(stream, "reading register...\n");
+  status = pcal6524_lld_read_reg(((aos_test_pcal6524data_t*)test->data)->pcal6524d, PCAL6524_LLD_CMD_SWITCHDEBOUNCECOUNT, buffer, ((aos_test_pcal6524data_t*)test->data)->timeout);
+  chprintf(stream, "\t\tdebounce count: %u\n", buffer[0]);
+  if ((status == APAL_STATUS_OK) || (status == APAL_STATUS_WARNING)) {
+    aosTestPassed(stream, &result);
+  } else {
+    aosTestFailedMsg(stream, &result, "0x%08X\n", status);
+  }
+
+  chprintf(stream, "writing register...\n");
+  buffer[3] = 0xFF;
+  status = pcal6524_lld_write_reg(((aos_test_pcal6524data_t*)test->data)->pcal6524d, PCAL6524_LLD_CMD_SWITCHDEBOUNCECOUNT, buffer[3], ((aos_test_pcal6524data_t*)test->data)->timeout);
+  status |= pcal6524_lld_read_reg(((aos_test_pcal6524data_t*)test->data)->pcal6524d, PCAL6524_LLD_CMD_SWITCHDEBOUNCECOUNT, &buffer[4], ((aos_test_pcal6524data_t*)test->data)->timeout);
+  status |= pcal6524_lld_write_reg(((aos_test_pcal6524data_t*)test->data)->pcal6524d, PCAL6524_LLD_CMD_SWITCHDEBOUNCECOUNT, buffer[0], ((aos_test_pcal6524data_t*)test->data)->timeout);
+  status |= pcal6524_lld_read_reg(((aos_test_pcal6524data_t*)test->data)->pcal6524d, PCAL6524_LLD_CMD_SWITCHDEBOUNCECOUNT, &buffer[1], ((aos_test_pcal6524data_t*)test->data)->timeout);
+  if (((status == APAL_STATUS_OK) || (status == APAL_STATUS_WARNING)) &&
+      ((buffer[1] == buffer[0]) && (buffer[4] == buffer[3]))) {
+    aosTestPassed(stream, &result);
+  } else {
+    aosTestFailedMsg(stream, &result, "0x%08X\n", status);
+  }
+
+  chprintf(stream, "reading group...\n");
+  status = pcal6524_lld_read_group(((aos_test_pcal6524data_t*)test->data)->pcal6524d, PCAL6524_LLD_CMD_OUTPUTDRIVESTRENGTH_P0A, buffer, ((aos_test_pcal6524data_t*)test->data)->timeout);
+  chprintf(stream, "\t\toutput drive strength: 0x%04X 0x%04X 0x%04X\n",
+           (((uint16_t)buffer[0]) << 8) | buffer[1],
+           (((uint16_t)buffer[2]) << 8) | buffer[3],
+           (((uint16_t)buffer[4]) << 8) | buffer[5]);
+  if ((status == APAL_STATUS_OK) || (status == APAL_STATUS_WARNING)) {
+    aosTestPassed(stream, &result);
+  } else {
+    aosTestFailedMsg(stream, &result, "0x%08X\n", status);
+  }
+
+  chprintf(stream, "writing group...\n");
+  memset(&buffer[6], PCAL6524_LL_OUTPUTDRIVESTRENGTH_0_25, 6);
+  status = pcal6524_lld_write_group(((aos_test_pcal6524data_t*)test->data)->pcal6524d, PCAL6524_LLD_CMD_OUTPUTDRIVESTRENGTH_P0A, &buffer[6], ((aos_test_pcal6524data_t*)test->data)->timeout);
+  status |= pcal6524_lld_read_group(((aos_test_pcal6524data_t*)test->data)->pcal6524d, PCAL6524_LLD_CMD_OUTPUTDRIVESTRENGTH_P0A, &buffer[12], ((aos_test_pcal6524data_t*)test->data)->timeout);
+  status |= pcal6524_lld_write_group(((aos_test_pcal6524data_t*)test->data)->pcal6524d, PCAL6524_LLD_CMD_OUTPUTDRIVESTRENGTH_P0A, &buffer[0], ((aos_test_pcal6524data_t*)test->data)->timeout);
+  status |= pcal6524_lld_read_group(((aos_test_pcal6524data_t*)test->data)->pcal6524d, PCAL6524_LLD_CMD_OUTPUTDRIVESTRENGTH_P0A, &buffer[18], ((aos_test_pcal6524data_t*)test->data)->timeout);
+  if (((status == APAL_STATUS_OK) || (status == APAL_STATUS_WARNING)) &&
+      ((memcmp(&buffer[12], &buffer[6], 6) == 0) && (memcmp(&buffer[18], &buffer[0], 6) == 0))) {
+    aosTestPassed(stream, &result);
+  } else {
+    aosTestFailedMsg(stream, &result, "0x%08X\n", status);
+  }
+
+  chprintf(stream, "reading continuously...\n");
+  // read the following registers continously (24 bytes):
+  // output 0-3 + polarity inversions 0-3 + configuration 0-3 + output drive strength 0A-2B + input latch 0-3 + pupd enable 0-3 + pupd selection 0-3
+  status = pcal6524_lld_read_continuous(((aos_test_pcal6524data_t*)test->data)->pcal6524d, PCAL6524_LLD_CMD_OUTPUT_P0, buffer, 24, ((aos_test_pcal6524data_t*)test->data)->timeout);
+  chprintf(stream, "\t\toutput: 0x%02X 0x%02X 0x%02X\n", buffer[0], buffer[1], buffer[2]);
+  chprintf(stream, "\t\tpolarity inversion: 0x%02X 0x%02X 0x%02X\n", buffer[3], buffer[4], buffer[5]);
+  chprintf(stream, "\t\tconfiguration: 0x%02X 0x%02X 0x%02X\n", buffer[6], buffer[7], buffer[8]);
+  chprintf(stream, "\t\toutput drive strength: 0x%04X 0x%04X 0x%04X\n",
+           (((uint16_t)buffer[9]) << 8) | buffer[10],
+           (((uint16_t)buffer[11]) << 8) | buffer[12],
+           (((uint16_t)buffer[13]) << 8) | buffer[14]);
+  chprintf(stream, "\t\tinput latch: 0x%02X 0x%02X 0x%02X\n", buffer[15], buffer[16], buffer[17]);
+  chprintf(stream, "\t\tpupd enable: 0x%02X 0x%02X 0x%02X\n", buffer[18], buffer[19], buffer[20]);
+  chprintf(stream, "\t\tpupd selection: 0x%02X 0x%02X 0x%02X\n", buffer[21], buffer[22], buffer[23]);
+  if ((status == APAL_STATUS_OK) || (status == APAL_STATUS_WARNING)) {
+    aosTestPassed(stream, &result);
+  } else {
+    aosTestFailedMsg(stream, &result, "0x%08X\n", status);
+  }
+
+  chprintf(stream, "writing continuously...\n");
+  {
+    uint8_t writebuffer[24];
+    uint8_t readbuffer[2][24];
+    // copy the read configuration but set the output drive strength to factor 0.25
+    memcpy(writebuffer, buffer, sizeof(buffer));
+    memset(&writebuffer[9], PCAL6524_LL_OUTPUTDRIVESTRENGTH_0_25, 6);
+    status = pcal6524_lld_write_continuous(((aos_test_pcal6524data_t*)test->data)->pcal6524d, PCAL6524_LLD_CMD_OUTPUT_P0, writebuffer, 24, ((aos_test_pcal6524data_t*)test->data)->timeout);
+    status |= pcal6524_lld_read_continuous(((aos_test_pcal6524data_t*)test->data)->pcal6524d, PCAL6524_LLD_CMD_OUTPUT_P0, readbuffer[0], 24, ((aos_test_pcal6524data_t*)test->data)->timeout);
+    status |= pcal6524_lld_write_continuous(((aos_test_pcal6524data_t*)test->data)->pcal6524d, PCAL6524_LLD_CMD_OUTPUT_P0, buffer, 24, ((aos_test_pcal6524data_t*)test->data)->timeout);
+    status |= pcal6524_lld_read_continuous(((aos_test_pcal6524data_t*)test->data)->pcal6524d, PCAL6524_LLD_CMD_OUTPUT_P0, readbuffer[1], 24, ((aos_test_pcal6524data_t*)test->data)->timeout);
+    if (((status == APAL_STATUS_OK) || (status == APAL_STATUS_WARNING)) &&
+        ((memcmp(writebuffer, readbuffer[0], 24) == 0) && (memcmp(buffer, readbuffer[1], 24) == 0))) {
+      aosTestPassed(stream, &result);
+    } else {
+      aosTestFailedMsg(stream, &result, "0x%08X\n", status);
+    }
+  }
+
+  aosTestInfoMsg(stream, "driver object memory footprint: %u bytes\n", sizeof(PCAL6524Driver));
+
+  return result;
+}
+
+#endif /* (AMIROOS_CFG_TESTS_ENABLE == true) */
diff --git a/test/periphery-lld/PCAL6524_v1/aos_test_PCAL6524.h b/test/periphery-lld/PCAL6524_v1/aos_test_PCAL6524.h
new file mode 100644
index 0000000..63c733a
--- /dev/null
+++ b/test/periphery-lld/PCAL6524_v1/aos_test_PCAL6524.h
@@ -0,0 +1,81 @@
+/*
+AMiRo-OS is an operating system designed for the Autonomous Mini Robot (AMiRo) platform.
+Copyright (C) 2016..2019  Thomas Schöpping et al.
+
+This program is free software: you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation, either version 3 of the License, or
+(at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#ifndef AMIROOS_TEST_PCAL6524_H
+#define AMIROOS_TEST_PCAL6524_H
+
+#include <amiroos.h>
+
+#if (AMIROOS_CFG_TESTS_ENABLE == true) || defined(__DOXYGEN__)
+
+#include <alld_PCAL6524.h>
+
+/******************************************************************************/
+/* CONSTANTS                                                                  */
+/******************************************************************************/
+
+/******************************************************************************/
+/* SETTINGS                                                                   */
+/******************************************************************************/
+
+/******************************************************************************/
+/* CHECKS                                                                     */
+/******************************************************************************/
+
+/******************************************************************************/
+/* DATA STRUCTURES AND TYPES                                                  */
+/******************************************************************************/
+
+/**
+ * @brief   Custom data structure for the test.
+ */
+typedef struct {
+  /**
+   * @brief   pointer to the PCAL6524 driver to use.
+   */
+  PCAL6524Driver* pcal6524d;
+
+  /**
+   * @brief   Timeout value (in µs).
+   */
+  apalTime_t timeout;
+} aos_test_pcal6524data_t;
+
+/******************************************************************************/
+/* MACROS                                                                     */
+/******************************************************************************/
+
+/******************************************************************************/
+/* EXTERN DECLARATIONS                                                        */
+/******************************************************************************/
+
+#if defined(__cplusplus)
+extern "C" {
+#endif /* defined(__cplusplus) */
+  aos_testresult_t aosTestPcal6524Func(BaseSequentialStream* stream, const aos_test_t *test);
+#if defined(__cplusplus)
+}
+#endif /* defined(__cplusplus) */
+
+/******************************************************************************/
+/* INLINE FUNCTIONS                                                           */
+/******************************************************************************/
+
+#endif /* (AMIROOS_CFG_TESTS_ENABLE == true) */
+
+#endif /* AMIROOS_TEST_PCAL6524_H */
diff --git a/test/periphery-lld/PKxxxExxx_v1/aos_test_PKxxxExxx.c b/test/periphery-lld/PKxxxExxx_v1/aos_test_PKxxxExxx.c
new file mode 100644
index 0000000..45716f5
--- /dev/null
+++ b/test/periphery-lld/PKxxxExxx_v1/aos_test_PKxxxExxx.c
@@ -0,0 +1,79 @@
+/*
+AMiRo-OS is an operating system designed for the Autonomous Mini Robot (AMiRo) platform.
+Copyright (C) 2016..2019  Thomas Schöpping et al.
+
+This program is free software: you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation, either version 3 of the License, or
+(at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#include <amiroos.h>
+#include <aos_test_PKxxxExxx.h>
+
+#if (AMIROOS_CFG_TESTS_ENABLE == true) || defined(__DOXYGEN__)
+
+/******************************************************************************/
+/* LOCAL DEFINITIONS                                                          */
+/******************************************************************************/
+
+/******************************************************************************/
+/* EXPORTED VARIABLES                                                         */
+/******************************************************************************/
+
+/******************************************************************************/
+/* LOCAL TYPES                                                                */
+/******************************************************************************/
+
+/******************************************************************************/
+/* LOCAL VARIABLES                                                            */
+/******************************************************************************/
+
+/******************************************************************************/
+/* LOCAL FUNCTIONS                                                            */
+/******************************************************************************/
+
+/******************************************************************************/
+/* EXPORTED FUNCTIONS                                                         */
+/******************************************************************************/
+
+aos_testresult_t aosTestPkxxxexxxFunc(BaseSequentialStream* stream, const aos_test_t* test)
+{
+  aosDbgCheck(test->data != NULL && ((aos_test_pkxxxexxxdata_t*)test->data)->driver != NULL);
+
+  // local variables
+  aos_testresult_t result = {0, 0};
+  uint32_t status;
+
+  chprintf(stream, "checking PWM configuration...\n");
+  status = pkxxxexxx_lld_checkPWMconfiguration(((aos_test_pkxxxexxxdata_t*)test->data)->driver);
+  if (status == APAL_STATUS_OK) {
+    aosTestPassed(stream, &result);
+  } else {
+    aosTestFailedMsg(stream, &result, "0x%08X\n", status);
+    // abort at this point
+    return result;
+  }
+
+  chprintf(stream, "buzzing for one second...\n");
+  status = pkxxxexxx_lld_enable(((aos_test_pkxxxexxxdata_t*)test->data)->driver, ((aos_test_pkxxxexxxdata_t*)test->data)->channel, true);
+  aosThdSSleep(1);
+  status |= pkxxxexxx_lld_enable(((aos_test_pkxxxexxxdata_t*)test->data)->driver, ((aos_test_pkxxxexxxdata_t*)test->data)->channel, false);
+  if (status == APAL_STATUS_OK) {
+    aosTestPassed(stream, &result);
+  } else {
+    aosTestFailedMsg(stream, &result, "0x%08X\n", status);
+  }
+
+  return result;
+}
+
+#endif /* AMIROOS_CFG_TESTS_ENABLE == true) */
diff --git a/test/periphery-lld/PKxxxExxx_v1/aos_test_PKxxxExxx.h b/test/periphery-lld/PKxxxExxx_v1/aos_test_PKxxxExxx.h
new file mode 100644
index 0000000..ece8a75
--- /dev/null
+++ b/test/periphery-lld/PKxxxExxx_v1/aos_test_PKxxxExxx.h
@@ -0,0 +1,81 @@
+/*
+AMiRo-OS is an operating system designed for the Autonomous Mini Robot (AMiRo) platform.
+Copyright (C) 2016..2019  Thomas Schöpping et al.
+
+This program is free software: you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation, either version 3 of the License, or
+(at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#ifndef AMIROOS_TEST_PKxxxExxx_H
+#define AMIROOS_TEST_PKxxxExxx_H
+
+#include <amiroos.h>
+
+#if (AMIROOS_CFG_TESTS_ENABLE == true) || defined(__DOXYGEN__)
+
+#include <alld_PKxxxExxx.h>
+
+/******************************************************************************/
+/* CONSTANTS                                                                  */
+/******************************************************************************/
+
+/******************************************************************************/
+/* SETTINGS                                                                   */
+/******************************************************************************/
+
+/******************************************************************************/
+/* CHECKS                                                                     */
+/******************************************************************************/
+
+/******************************************************************************/
+/* DATA STRUCTURES AND TYPES                                                  */
+/******************************************************************************/
+
+/**
+ * @brief   Custom data structure for the test.
+ */
+typedef struct {
+  /**
+   * @brief   Pointer to the PWM driver.
+   */
+  apalPWMDriver_t* driver;
+
+  /**
+   * @brief   PWM channel to use.
+   */
+  apalPWMchannel_t channel;
+} aos_test_pkxxxexxxdata_t;
+
+/******************************************************************************/
+/* MACROS                                                                     */
+/******************************************************************************/
+
+/******************************************************************************/
+/* EXTERN DECLARATIONS                                                        */
+/******************************************************************************/
+
+#if defined(__cplusplus)
+extern "C" {
+#endif /* defined(__cplusplus) */
+  aos_testresult_t aosTestPkxxxexxxFunc(BaseSequentialStream* stream, const aos_test_t* test);
+#if defined(__cplusplus)
+}
+#endif /* defined(__cplusplus) */
+
+/******************************************************************************/
+/* INLINE FUNCTIONS                                                           */
+/******************************************************************************/
+
+#endif /* (AMIROOS_CFG_TESTS_ENABLE == true) */
+
+#endif /* AMIROOS_TEST_PKxxxExxx_H */
